# connector-ca
Connect CA API provides methods to create and get Developer certificate. Also Connect CA provides server-credentials for Bootstarp and LWM2M Server.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 3
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import connector_ca 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import connector_ca
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import connector_ca
from connector_ca.rest import ApiException
from pprint import pprint

# Configure API key authorization: Bearer
connector_ca.configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# connector_ca.configuration.api_key_prefix['Authorization'] = 'Bearer'
# create an instance of the API class
api_instance = connector_ca.DeveloperCertificateApi()
muuid = 'muuid_example' # str | A unique identifier for the developer certificate. 
authorization = 'authorization_example' # str | Bearer {Access Token}. 

try:
    # Fetch an existing developer certificate to connect to the bootstrap server.
    api_response = api_instance.v3_developer_certificates_muuid_get(muuid, authorization)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DeveloperCertificateApi->v3_developer_certificates_muuid_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://api.us-east-1.mbedcloud.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DeveloperCertificateApi* | [**v3_developer_certificates_muuid_get**](docs/DeveloperCertificateApi.md#v3_developer_certificates_muuid_get) | **GET** /v3/developer-certificates/{muuid} | Fetch an existing developer certificate to connect to the bootstrap server.
*DeveloperCertificateApi* | [**v3_developer_certificates_post**](docs/DeveloperCertificateApi.md#v3_developer_certificates_post) | **POST** /v3/developer-certificates | Create a new developer certificate to connect to the bootstrap server.
*ExternalAPIApi* | [**v3_developer_certificates_muuid_get**](docs/ExternalAPIApi.md#v3_developer_certificates_muuid_get) | **GET** /v3/developer-certificates/{muuid} | Fetch an existing developer certificate to connect to the bootstrap server.
*ExternalAPIApi* | [**v3_developer_certificates_post**](docs/ExternalAPIApi.md#v3_developer_certificates_post) | **POST** /v3/developer-certificates | Create a new developer certificate to connect to the bootstrap server.
*ExternalAPIApi* | [**v3_server_credentials_bootstrap_get**](docs/ExternalAPIApi.md#v3_server_credentials_bootstrap_get) | **GET** /v3/server-credentials/bootstrap | Fetch bootstrap server credentials.
*ExternalAPIApi* | [**v3_server_credentials_lwm2m_get**](docs/ExternalAPIApi.md#v3_server_credentials_lwm2m_get) | **GET** /v3/server-credentials/lwm2m | Fetch LWM2M server credentials.
*ServerCredentialsApi* | [**v3_server_credentials_bootstrap_get**](docs/ServerCredentialsApi.md#v3_server_credentials_bootstrap_get) | **GET** /v3/server-credentials/bootstrap | Fetch bootstrap server credentials.
*ServerCredentialsApi* | [**v3_server_credentials_lwm2m_get**](docs/ServerCredentialsApi.md#v3_server_credentials_lwm2m_get) | **GET** /v3/server-credentials/lwm2m | Fetch LWM2M server credentials.


## Documentation For Models

 - [DeveloperCertificateRequestData](docs/DeveloperCertificateRequestData.md)
 - [DeveloperCertificateResponseData](docs/DeveloperCertificateResponseData.md)
 - [ServerCredentialsResponseData](docs/ServerCredentialsResponseData.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author



